# Magic App

[![Build Status](https://drone.autonomic.zone/api/badges/autonomic-cooperative/magic-app/status.svg)](https://drone.autonomic.zone/autonomic-cooperative/magic-app)

A swarm of dreams.

## Proof-of-concept

- [ ] List apps that are templated under https://git.autonomic.zone/compose-stacks
- [ ] Clone selected app template and parse configuration for inputs (env vars and secrets)
- [ ] Generate a form so those values can be filled out
- [ ] Save the form inputs to a `db.json`
- [ ] Deploy an applicaiton to a local swarm (assumes access to local docker socket)
- [ ] Create an "edit app" page where the `db.json` is re-called and can be updated
- [ ] Make sure re-deploy works (taking care of updating secret and app versions)

## Run It

### Go Go Go No Docker

```bash
$ python3 -m venv .venv && source .venv/bin/activate
$ pip install -r requirements.txt
$ make python-run
```

### Go Go Go Yes Docker

```bash
$ make docker-build
$ make docker-run
```

### Go Go Go Yes Docker Compose

```bash
$ pip install "docker-compose>=1.26.0,<2"
$ make compose-run
```
